translateapp/accounts/urls.py
from django.urls import path
from . import views

app_name = "accounts"

urlpatterns = [
        path('dashboard', views.dashboard, name="dashboard"),
        path('profile/<int:user_id>', views.profile, name="profile"),
        path('register', views.register, name="register"),
]

translateapp/app/urls.py
from django.urls import path
from . import views

app_name = "app"
urlpatterns = [
        path('jobs', views.jobs_index, name="jobs"),
        path('jobs/new', views.new_job, name="new_job"),
        path('jobs/<int:job_id>', views.job_detail, name="job_detail"),
        path('jobs/<int:job_id>/bid', views.bid, name="bid"),
        path('bids/<int:bid_id>/accept', views.accept_bid, name="accept_bid"),
        path('bids/<int:bid_id>/deliver', views.deliver_translation, name="deliver_translation"),
        path('bids/<int:bid_id>', views.bid_detail, name="bid_detail"),
        path('bids/<int:bid_id>/rating', views.rate_bid, name="rate_bid"),
        path('bids/<int:bid_id>/dispute', views.raise_dispute, name="dispute"),
        path('message/<int:receiver_id>', views.send_message, name="send_message"),
]

translateapp/translateapp/urls.py
from django.contrib import admin
from django.urls import path, include

from app import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.home, name='home_path'),
    path('app/', include('app.urls')),
    path('messenger/', include('messenger.urls')),
    path('accounts/', include('accounts.urls')),
    path('accounts/', include('django.contrib.auth.urls'))
]

translateapp/accounts/models.py
from django.db import models

# Create your models here.

translateapp/app/models.py
from django.db import models

from django.contrib.auth.models import User
from django.db.models import Q

class Account(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    name = models.CharField(max_length=100)
    balance = models.DecimalField(max_digits=8, decimal_places=2, default=0)
    translator = models.BooleanField()
    def __str__(self):
        return f"{self.id} - {self.name}"

    def rating(self):
        ratings = Rating.objects.filter(rated=self.user)
        if ratings.count() == 0:
            return "No ratings yet"
        else:
            score = [ rating.rating for rating in ratings ]
            return sum(score) / len(score)

    def raise_if_invalid_balance(self):
        if self.balance < 0:
            raise ValueError("Balance cannot be negative")

    def active_jobs(self):
        return self.user.job_set.exclude(status='completed')

    def completed_jobs(self):
        return self.user.job_set.filter(status='completed')

class Job(models.Model):
    class Status(models.TextChoices):
        AVAILABLE = 'available', "Available"
        ASSIGNED = 'assigned', "Assigned"
        IN_PROGRESS = 'in_progress', "In Progress"
        COMPLETED = 'completed', "Completed"

    class Field(models.TextChoices):
        ART = 'art', "Art"
        BUS = 'business', "Business"
        COMP = 'computers', "Computers"
        EDU = 'education', "Education"
        ENG = 'engineering', "Engineering"
        FIN = 'finance', "Finance"
        LAW = 'law', "Law"
        LIT = 'literature', "Literature"
        MED = 'medicine', "Medicine"
        SCI = 'science', "Science"
        SOC = 'social_sciences', "Social Sciences"
        TECH = 'technology', "Technology"

    class Language(models.TextChoices):
        ENG = 'en', "English"
        SPA = 'spa', "Spanish"
        FRE = 'fr', "French"
        GER = 'de', "German"
        ITA = 'it', "Italian"
        JPN = 'ja', "Japanese"
        CRO = 'hr', "Croatian"

    user = models.ForeignKey(User, on_delete=models.CASCADE)
    title = models.CharField(max_length=256)
    description = models.CharField(max_length=512)
    source_lang = models.CharField(
            max_length=3, 
            choices=Language.choices,
            default=Language.ENG,
    )
    target_lang = models.CharField(
            max_length=3,
            choices=Language.choices,
            default=Language.CRO,
    )
    field = models.CharField(
            max_length=100,
            choices=Field.choices,
            default=Field.ENG,
    )
    budget = models.DecimalField(max_digits=8, decimal_places=2)
    text = models.TextField()
    status = models.CharField(
            max_length=100, 
            choices=Status.choices,
            default=Status.AVAILABLE,
    )
    translation = models.TextField(blank=True, null=True)
    def __str__(self):
        return f"{self.user.account.name} - {self.title}"

    def accepted_bid(self):
        return self.bid_set.filter(accepted=True).first()

    def accepted_bidder(self):
        return self.accepted_bid().bidder.account

    def owner(self):
        return self.user.account

    # Helper method to check if the job is available, since checking the status
    # directly from the template is not very readable.
    def is_available(self):
        return self.status == self.Status.AVAILABLE

    def is_completed(self):
        return self.status == self.Status.COMPLETED

    def ordered_bids(self):
        return self.bid_set.order_by('-accepted')

    def bid_by_user(self, user):
        return self.bid_set.filter(bidder=user).first()

    def can_bid(self, user):
        # If user didn't bid already on the job and is not the job owner
        return self.bid_by_user(user) is None and self.user != user


    @classmethod
    def accepted_jobs_for(cls, user):
        # Svi bidovi gdje je user napravio job na koji je biddano
        accepted_bids = Bid.objects.filter(job__in=user.job_set.all(), accepted=True)
        # Svi jobovi gdje je user napravio job i bidano je na job 
        accepted_jobs = [ bid.job for bid in accepted_bids if bid.job.status != "completed" ]
        return accepted_jobs

class Bid(models.Model):
    bidder = models.ForeignKey(User, on_delete=models.CASCADE)
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    price = models.DecimalField(max_digits=8, decimal_places=2)
    accepted = models.BooleanField(default=False)
    completed = models.BooleanField(default=False)
    def __str__(self):
        return f"{self.bidder.account.name} - {self.job.title} - {self.price}"
    def job_owner(self):
        return self.job.user

class Dispute(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    bid = models.OneToOneField(Bid, on_delete=models.CASCADE)
    reason = models.TextField(blank=False, null=False)

class Message(models.Model):
    sender = models.ForeignKey(User, on_delete=models.CASCADE, related_name='sender')
    receiver = models.ForeignKey(User, on_delete=models.CASCADE, related_name='receiver')
    text = models.TextField(blank=False, null=False)
    sent_at = models.DateTimeField(auto_now_add=True)
    def __str__(self):
        return f"{self.sender.account.name} - {self.receiver.account.name} - {self.text[:20]}"
    
    def text_snippet(self):
        return f"{self.text[:30]}..."

    @classmethod
    def get_thread(cls, user1, user2):
        return cls.objects.filter(sender__in=[user1, user2], receiver__in=[user1, user2]).order_by('sent_at')

    @classmethod
    def get_thread_users(cls, user):
        # Using Q objects
        #https://docs.djangoproject.com/en/4.1/topics/db/queries/#complex-lookups-with-q-objects
        
        messages = Message.objects.filter(Q(sender=user) | Q(receiver=user)).order_by('-sent_at')
        ordered_users = []
        for message in messages:
            if message.sender != user and message.sender not in ordered_users:
                ordered_users.append(message.sender)
            if message.receiver != user and message.receiver not in ordered_users:
                ordered_users.append(message.receiver)

        return ordered_users

    @classmethod
    def get_threads_for(cls, my_user):
        users = cls.get_thread_users(my_user)
        threads = [ [user, cls.get_thread(my_user, user)] for user in users ]
        return threads

class Rating(models.Model):
    rater = models.ForeignKey(User, on_delete=models.CASCADE, related_name='rater')
    rated = models.ForeignKey(User, on_delete=models.CASCADE, related_name='rated')
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    bid = models.OneToOneField(Bid, on_delete=models.CASCADE)
    rating = models.IntegerField()

translateapp/accounts/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, HttpResponseRedirect
from django.utils import timezone
from django.urls import reverse
from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from app.models import Account, Job, Bid, Dispute, Message, Rating
from app.forms import UserForm, AccountForm


# Create your views here.

# See the comment in forms.py for an explanation of why we use two forms
def register(request):
    if request.method == 'POST':
        # Each form is validated separately, each form takes the data from the
        # request that is relevant to it.
        user_form = UserForm(request.POST)
        account_form = AccountForm(request.POST)
        # Only if both forms are valid, we save the data to the database
        if user_form.is_valid() and account_form.is_valid():
            user = user_form.save()
            # We need to set the password separately, because the UserForm
            # doesn't have a password field, it uses two fields for the password
            # and password confirmation.
            user.set_password(user_form.cleaned_data['password1'])
            user.save()

            # We need to set the user field on the account before we can save it
            account = account_form.save(commit=False)
            account.user = user
            account.save()
            return HttpResponseRedirect(reverse('accounts:dashboard'))
        else:
            return render(request, 'accounts/register.html', {'user_form': user_form, 'account_form': account_form})
    else:
        user_form = UserForm()
        account_form = AccountForm()
        return render(request, 'accounts/register.html', {'user_form': user_form, 'account_form': account_form})

@login_required
def dashboard(request):
    user = request.user
    my_jobs = user.job_set.all()
    my_completed_jobs = user.account.completed_jobs()
    my_active_jobs = user.account.active_jobs()

    my_threads = Message.get_threads_for(user)

    my_bids = user.bid_set.all()
    my_won_bids = user.bid_set.filter(accepted=True)
    context = {
        'my_jobs': my_jobs,
        'my_active_jobs': my_active_jobs,
        'my_completed_jobs': my_completed_jobs,
        'my_threads': my_threads,
        'my_bids': my_bids,
        'my_won_bids': my_won_bids,
    }

    return render(request, 'accounts/dashboard.html', context)


def profile(request, user_id):
    user = get_object_or_404(User, pk=user_id)

    accepted_jobs = Job.accepted_jobs_for(user)
    completed_jobs = Job.objects.filter(user=user, status='completed')

    bids = user.bid_set.all()
    won = user.bid_set.filter(accepted=True)

    context = {
        'profile_user': user,
        'accepted_jobs': accepted_jobs,
        'completed_jobs': completed_jobs,
        'bids': bids,
        'won': won,
    }
    return render(request, 'accounts/profile.html', context)

translateapp/accounts/templates/includes/job_card.html
<div class="card my-4 shadow p-2 mb-5 rounded">
    <div class="card-body m-2">
      <div class="row">
        <h4 class="card-title">{{ job.title }}</h4>
      </div>
      <div class="card-subtitle mb-2 mt-1 ">{{ job.description }}</div>
      <div class="card-text mb-2 mt-3 text-muted">Field: {{ job.field }}</div>
      <div class="card-text mb-2 text-muted">Source language: {{ job.source_lang }}</div>
      <div class="card-text mb-2 text-muted">Target language: {{ job.target_lang }}</div>
      <div class="card-text mb-2 text-muted">Budget: {{ job.budget }} tokens</div>
      
      <div class="card-text mb-2 mt-3 "> Status: {{ job.status }}</div>
      <div>{{ job.accepted_bidder.name }} was accepted for this job with the 
        bid of {{ job.accepted_bid.price }} </div>
      
    </div>
  </div>

translateapp/accounts/templates/includes/message_card.html
{% load static %}

<head>
    <link rel="stylesheet" href="{% static 'app/css/message_card.css' %}">
</head>

<div id="container">
    <main>
  
      <ul id="chat">
        <li class="{% if user == message.sender %} me {% else %} you {% endif %}">
          <div class="entete">
            <span class=" status {% if user == message.sender %} blue {% else %} green {% endif %}"></span>
            <h2>{% if user == message.sender %} 
                    {{ message.sender }}
                {% else %} 
                    <a href="{% url 'accounts:profile' message.sender.id %}">
                        {{ message.sender.account.name }}
                    </a> 
                {% endif %}
            </h2>
            <h3>{{ message.sent_at }}</h3>
          </div>
          <div class="message">
            {{ message.text }}
          </div>
        </li>
        
    </main>
  </div>
  

translateapp/accounts/templates/includes/my_bid_card.html
<div class="card my-4 shadow-sm p-3 mb-5 rounded card-body m-2 rounded bid {% if bid.accepted %} accepted {% endif %}">
    <p>
    <strong>My bid on {{ bid.job.title }} for {{ bid.price }} tokens.</strong>
    </p>
    <p>
    {{ bid.job.description }}</br>
    From {{ bid.job.get_source_lang_display }} to {{ bid.job.get_target_lang_display }}.
    </p>
    <p>Field: {{ bid.job.get_field_display }}; Status:  {{ bid.job.status   }}</p>

    {% if not bid.completed %}
        <p><a href="{% url 'app:deliver_translation' bid.id %}">Submit your translation</a></p>
    {% elif bid.completed %}
        <p>
        <a href="{% url 'app:bid_detail' bid.id %}">See the completed translation</a>
        </p>
    {% endif %}
</div>
  

translateapp/accounts/templates/includes/my_job_card.html
<div class="card my-4 shadow-sm p-2 mb-5 rounded w-75">
    <div class="card-body m-2">
        <div class="row">
            <h3 class="card-title">{{ job.title }}</h3>
        </div>
        <div class="card-subtitle mb-2 mt-1 ">{{ job.description }}</div>
        <div class="card-text mb-2 mt-3 text-muted">Source language: {{ job.get_source_lang_display }}</div>
        <div class="card-text mb-2 text-muted">Target language: {{ job.get_target_lang_display }}</div>
        <div class="card-text mb-2  text-muted">Field: {{ job.get_field_display }}</div>
        <div class="card-text mb-2 text-muted">Budget: {{ job.budget }} tokens</div>
        <div class="card-text mb-2 mt-3 text-muted"> Status: {{ job.status }}</div>

        
        {% for bid in bids %}
        <div class="card mt-3 p-2 rounded bid {% if bid.accepted %} accepted {% endif %}">
            <h4>
            Bidder: 
            <a href="{% url 'accounts:profile' bid.bidder.id %}">
                {{ bid.bidder.account.name }}
            </a>
            </h4>
            <p class="mt-2">
            <strong>Price: {{ bid.price }}</strong>, 
            Accepted: {{ bid.accepted }}
            </p>
            {% if not bid.accepted and job.is_available %}
            <!--check models.py for the is_available method-->
            <p>
                <form action="{% url 'app:accept_bid' bid.id %}" method="post">
                {% csrf_token %}
                <input type="submit" value="Accept bid">
                </form>
            </p>
            {% elif bid.completed %}
            <p>
                <span class="me-2">{% if bid.rating %} You rated it {{ bid.rating.rating }} {% endif %}</span>
                <a href="{% url 'app:bid_detail' bid.id %}">See the completed translation</a>
            </p>
            {% endif %}
        </div>
        {% endfor %}
    </div>
</div>